# $Id: esr_mate.rb,v 1.9 2006/10/19 05:28:56 nisyu Exp $

class EsrMaterial
	include BOS::PropMethods
	include BOS::SetupMethods
	attr_reader :base_qt
	
	Table_name = "bos_#{BOS::Prop[:site_name]}_esr_materials"
	
	def initialize(mate_id,base_qt=1)
		@base_qt = base_qt
		setup
		if !(mate_id.is_a? Numeric) || !(mate_id.integer?)
			mate_id = mate_id.to_i == 0 ? get_id(mate_id) : mate_id.to_i
		end
		if mate_id and mate_id != 0
			load_id(mate_id)
		end
	end
	
	def setup_db
		@mydb.query("CREATE TABLE #{Table_name}(" +
			"material_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"material_name TEXT NOT NULL," +
			"material_code VARCHAR(255) NOT NULL," +
			"inventory INT NOT NULL," +
			"r_inventory INT NOT NULL," +
			"cost INT NOT NULL," +
			"disp_flg CHAR(1) NOT NULL);")
	end
	
	def set_default
		{
			:material_id => 0,
			:material_name => 'new material',
			:material_code => '',
			:inventory => 0,
			:r_inventory => 0,
			:cost => 0,
			:disp_flg => 'p' }
	end
	
	def load_id(pid)
		return nil unless pid
		@prop = @mydo.exp({
			:command => "s",
			:target  => Table_name,
			:cols    => set_default,
			:where   => w('material_id'){|a| a == pid } })[0]
		@prop[:material_id]
	end
	
	def get_cost
	  @prop[:cost] * @base_qt
	end
	
	def get_inventory(r=false)
		(r ? @prop[:r_inventory] : @prop[:inventory]) / @base_qt
	end
	
	def set_inventory(qt, r=false)
		retct = nil
		qt = qt * @base_qt
		minv = r ? :r_inventory : :inventory
		if (@prop[:inventory] + qt) >= 0
			@prop[minv] = @prop[minv] + qt
			@prop[:inventory] = @prop[:inventory] + qt if r
			commit
		else
			retct = @prop[minv]
		end
		return retct
	end
	
	def set_inventory_to_r(qt)
		retct = nil
		qtex = qt * @base_qt
		rt_diff = get_inventory(true) - get_inventory
		if rt_diff >= qt
			@prop[:r_inventory] = @prop[:r_inventory] - qtex
			commit
		else
			retct = rt_diff
		end
		return retct
	end
	
	def get_list(pg=1, pc=10, sc="", sb=nil)
		pg = pg || 1
		pc = pc || 10
		@mydo.exp({
			:command => "s",
			:target  => Table_name,
			:cols    => set_default,
			:order   => sb ? "#{sb[:key]} #{sb[:mode]}" : "material_id DESC",
			:page    => pg,
			:pagesize => pc })
	end
	
	def get_plist
	  EsrItem.new(0).get_mate_plist @prop[:material_id]
	end
	
	def commit
		if @prop[:material_id] == 0
			@prop.delete(:material_id)
			@prop[:material_id] = @mydo.exp({
				:command => "i",
				:target  => Table_name,
				:cols    => @prop })[:insid]
		else
			lct = @mydo.exp({
				:command => "u",
				:target  => Table_name,
				:cols    => @prop,
				:where   => w("material_id"){|a| a == @prop[:material_id]}})
		end
		
		@prop[:material_id]
	end

end
