# $Id: esr_order.rb,v 1.8 2006/10/24 08:27:13 nisyu Exp $

class EsrOrder
	include BOS::PropMethods
	include BOS::SetupMethods
	attr_accessor :delivery_address, :user_address
	
	Table_name = "bos_#{BOS::Prop[:site_name]}_esr_orders"
	Table_name_i = "bos_#{BOS::Prop[:site_name]}_esr_order_items"
	
	def initialize(sid,order_id=nil)
		setup
		@key_id = 's'
		load_id(sid,order_id)
		calc_total
	end
	
	def calc_total
	  tot = 0
	  if @item_list
	    @item_list.each{|item| tot += item[:total] }
	  end
	  
	  @prop[:total] = tot
	end
	
	def load_id(sid,order_id=nil)
		return nil unless sid
		if order_id
  		@prop = @mydo.exp({
  			:command => "s",
  			:target  => Table_name,
  			:cols    => set_default,
  			:where   => w('order_id'){|a| a == order_id } })[0]
      @key_id = 'o'
  	else
  		@prop = @mydo.exp({
  			:command => "s",
  			:target  => Table_name,
  			:cols    => set_default,
  			:where   => w('session_id','order_flg'){|a,b| (a == sid) & (b == nil) } })[0]
      @key_id = 's'
  	end
		unless @prop
      @prop = set_default
      @prop[:session_id] = sid
      @prop[:order_flg] = nil
      @prop[:confirm_flg] = nil
      @prop[:ship_flg] = nil
      @prop[:payment_flg] = nil
      @prop[:cancel_flg] = nil
      commit
    end
		@delivery_address = BosAddress.new(@prop[:delivery_address_id])
		@user_address = BosAddress.new(@prop[:user_address_id])
		
		order_item_list(true)
	end
	
	def clear_cart
	  return nil unless @item_list || @item_list.size == 0
	  
	  @item_list.each do |it|
	    add_item(it[:item_id],-it[:quantity])
	  end
	  order_item_list(true)
	end
	
	def add_item(i_item,qt)
	  unless i_item.class == EsrItem
      i_item = EsrItem.new(i_item)
	  end
	  del_id = nil
	  seti = set_default('i')
	  seti[:order_id] = @prop[:order_id]
	  seti[:item_id] = i_item[:item_id]
	  seti[:item_name] = i_item[:item_name]
	  seti[:item_code] = i_item[:item_code]
	  seti[:price] = i_item[:price]
	  seti[:normal_price] = i_item[:normal_price]
	  seti[:pretax] = i_item[:pretax]
	  seti[:quantity] = qt
	  
	  if @item_list
	    @item_list.each{|item|
	      del_id = item if item[:item_id] == i_item[:item_id] }
	  end
	  
	  if i_item.get_inventory >= qt
	    i_item.set_inventory(-qt)
  	  if del_id
  	    @mydo.exp({
  	      :command => "d",
          :target  => Table_name_i,
          :where   => w('order_item_id'){|a| a == del_id[:order_item_id] } })
        seti[:quantity] = del_id[:quantity] + qt
  	  end
  	  if seti[:quantity] != 0
  	    seti[:total] = seti[:quantity] * seti[:price]
  	    @mydo.exp({
  	      :command => "i",
          :target  => Table_name_i,
    			:cols    => seti })
    	end
	  end
	  order_item_list(true)
	end
	
	def order_item_list(reload=false)
	  return nil unless @prop
	  if !@item_list || reload
      @item_list = @mydo.exp({
        :command => "s",
        :target  => Table_name_i,
        :cols    => set_default('i'),
        :order   => "order_item_id ASC",
        :where   => w('order_id'){|a| a == @prop[:order_id] } })
    end
    calc_total
    @item_list
	end
	
	def setup_db
		@mydb.query("CREATE TABLE #{Table_name}(" +
			"order_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"order_code VARCHAR(255) NOT NULL," +
			"registrant VARCHAR(20) NOT NULL," +
			"user_address_id INT NOT NULL," +
			"delivery_address_id INT NOT NULL," +
			"payment_method VARCHAR(32) NOT NULL," +
			"payment_method_charge INT NOT NULL," +
			"delivery_charge INT NOT NULL," +
			"tax INT NOT NULL," +
			"total INT NOT NULL," +
			"order_flg DATETIME," +
			"confirm_flg DATETIME," +
			"ship_flg DATETIME," +
			"payment_flg DATETIME," +
			"cancel_flg DATETIME," +
			"session_id VARCHAR(255));")
		@mydb.query("CREATE TABLE #{Table_name_i}(" +
			"order_item_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"order_id INT NOT NULL," +
			"item_id INT NOT NULL," +
			"item_name TEXT NOT NULL," +
			"item_code VARCHAR(255) ," +
			"option_id INT ," +
			"option_name VARCHAR(255) ," +
			"quantity INT NOT NULL," +
			"price INT NOT NULL," +
			"normal_price INT NOT NULL," +
			"pretax INT NOT NULL," +
			"total INT NOT NULL);")
	end
	
	def set_default(tfl=nil)
		case tfl
		when 'i'
		  {
		    :order_item_id => 0,
		    :order_id => 0,
		    :item_id => 0,
		    :item_name => "",
		    :item_code => nil,
		    :option_id => nil,
		    :option_name => nil,
		    :quantity => 0,
		    :price => 0,
		    :normal_price => 0,
		    :pretax => 0,
		    :total => 0 }
		else
		  {
  		  :order_id => 0,
  		  :order_code => "",
  			:registrant => "guest",
  			:user_address_id => 0,
  			:delivery_address_id => 0,
  			:payment_method => '',
  			:payment_method_charge => 0,
  			:delivery_charge => 0,
  			:tax => 0,
  			:total => 0,
  			:order_flg => DateTime.now,
  			:confirm_flg => DateTime.now,
  			:ship_flg => DateTime.now,
  			:payment_flg => DateTime.now,
  			:cancel_flg => DateTime.now,
  			:session_id => "" }
	  end
	end
	
	def order_chk
	  return true,"OK"
	end
	
	def get_list(pg=1, pc=10, sc="", sb=nil, wh=nil)
		pg = pg || 1
		pc = pc || 10
		@mydo.exp({
			:command => "s",
			:target  => Table_name,
			:cols    => set_default,
			:order   => sb ? "#{sb[:key]} #{sb[:mode]}" : "order_id DESC",
			:page    => pg,
			:where   => wh ? wh : w('order_flg'){|a| a ^= nil },
			:pagesize => pc })
	end
	
  def confirm(order_code=nil)
    chkfl,mess = order_chk
    if chkfl
      order_item_list(true).each{|im|
        EsrItem.new(im[:item_id]).set_inventory_to_r(im[:quantity]) }
      @prop[:order_flg] = DateTime.now
      @prop[:order_code] = (order_code || @prop[:order_id]).to_s
      calc_total
      commit
      ret = "ʸꤷޤ"
    else
      ret = mess
    end
    ret
  end
	
	def commit
		if @prop[:order_id] == 0 then
			@prop.delete(:order_id)
			@prop[:order_id] = @mydo.exp({
				:command => "i",
				:target  => Table_name,
				:cols    => @prop })[:insid]
		else
			@prop.delete(:session_id)
			lct = @mydo.exp({
				:command => "u",
				:target  => Table_name,
				:cols    => @prop,
				:where   => w("order_id"){|a| a == @prop[:order_id]} })
		end
		
		@prop[:order_id]
	end
	
end
