# $Id: esr_prod.rb,v 1.7 2006/10/21 07:47:38 nisyu Exp $

class EsrProduct < BosPagegen
	Table_name_r = "bos_#{BOS::Prop[:site_name]}_esr_product_r"
	
	def initialize(product_id)
		super
		setup_db_r if BOS::Prop[:sitesetup] && !@mydb.list_tables.include?(Table_name_r)
	end
	
	def load_image
	  @images = EsrImageSetPro.new(@prop[:product_id],'p')
	end
	
	def image(order_no)
	  load_image unless @images
	  return nil unless @images
	  ret = nil
	  @images.each{|im|
	    ret = im[:image_set] if im[:disp_order] == order_no.to_i }
    ret ? ret.get_image_urls : nil
  end
  
  def image_fast(order_no=1)
    im = EsrImageSetPro::fastimage(@prop[:product_id],'p',order_no)
    im ? im.get_image_urls : nil
  end
	
	def setup_db_r
		@mydb.query("CREATE TABLE #{Table_name_r}(" +
			"product_r_id INT NOT NULL AUTO_INCREMENT PRIMARY KEY," +
			"self_product_id INT NOT NULL," +
			"sub_item_id INT NOT NULL," +
			"disp_order INT NOT NULL);")
	end
	
	def set_default(tfl=nil)
		case tfl
		when 'r'
			{
				:product_r_id => 0,
				:self_product_id => 0,
				:sub_item_id => 0,
				:disp_order => 0 }
		else
			super()
		end
	end
	
	def get_item_list(r=false)
		rec = @mydo.exp({
			:command => "s",
			:target  => Table_name_r,
			:cols    => set_default('r'),
			:order   => "disp_order ASC",
			:where   => w("self_product_id"){|a| a == @prop[:product_id]}})
		if r
		  ret = rec
		else
		  ret = []
		  rec.each{|r| ret << EsrItem.new(r[:sub_item_id]) }
		end
		ret
	end
	
	def price
	  ret = 0
	  ie = ''
	  tl = get_item_list
	  tl.each{|i|
	    ret = i[:price] if i[:price] > ret }
	  if tl.size > 1
	    ie = ""
	  end
	  "#{ret.to_money(true)}#{ie}"
	end
	
	def get_item_plist(item_id)
	  deh = {:product_id=>0 , :product_name => ""}
		@mydo.exp({
			:command => "s",
			:target  => lj(Table_name,Table_name_r){|a,b| a[:product_id] == b[:self_product_id]},
			:cols    => deh,
			:where   => w('sub_item_id'){|a| a == item_id},
			:order   => "product_id DESC" })
	end
	
	def get_cate_list
	  deh = {:category_id=>0 , :category_name => ""}
		@mydo.exp({
			:command => "s",
			:target  => lj(BosCategory::Table_name,BosCategory::Table_name_r){|a,b| a[:category_id] == b[:self_category_id]},
			:cols    => deh,
			:where   => w('sub_type','sub_category_id'){|a,b| (a == 'p') & (b == @prop[:product_id]) },
			:order   => "category_id DESC" })
	end
	
	def add_cate(cid)
	  BosCategory.new(cid).add(@prop[:product_id],'p')
	end
	
	def del_cate(cid)
	  BosCategory.new(cid).del(@prop[:product_id],'p')
	end
	
	def clear_cate
	  get_cate_list.each{|c|
	    del_cate(c[:category_id]) }
	end
	
	def add_item(item_id,disp_order=0)
	  return nil unless item_id
	  del_item(item_id)
		@mydo.exp({
			:command => "i",
			:target  => Table_name_r,
			:cols    => {
				:self_product_id => @prop[:product_id],
				:sub_item_id => item_id.to_i,
				:disp_order => disp_order } })
	end

	def del_item(item_id)
	  return nil unless item_id
		@mydo.exp({
			:command => "d",
			:target  => Table_name_r,
			:where   => w('self_product_id','sub_item_id'){|a,b| (a == @prop[:product_id]) & (b == item_id.to_i) } })
	end
	
	def clear_item
	  get_item_list.each{|i|
	    del_item(i[:item_id]) }
	end
	
end
